{% extends "app/layout.html" %}

{% block content %}

    {% load staticfiles %}
    <link rel="stylesheet" type="text/css" href="{% static 'app/content/font-awesome.min.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'app/content/plot.css' %}" />
    <link rel="stylesheet" type="text/css" href="{% static 'app/content/bootstrap-datepicker-v1.6/bootstrap-datepicker3.standalone.css' %}" />


    <script src="{% static 'app/scripts/bootstrap-table.min.js' %}"></script>
    <script src="{% static 'app/scripts/moment.min.js' %}"></script>
    <script src="{% static 'app/scripts/utilities.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/highcharts.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/bootstrap-datepicker-v1.6/bootstrap-datepicker.js' %}"></script>



    {% if actor == None %}
        <h3>You have not been mapped to a known Market Actor. Please contact the Marketplace administrator.</h3>
    {% else %}

        
        <script type="text/javascript">
            var charts = [];
            var consumptionLabels = [];
            var generationLabels = [];
    

            $(document).ready(function () {
                $.ajax({
                    url: "{% url 'sgi_consumption_labels' %}",
                    type: "GET",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    success: function (labels) {
                        consumptionLabels = labels;
                        loadConsumptionGraph(labels);
                    },
                    error: function () {
                        console.error("Rule error");
                    }
                });

                $.ajax({
                    url: "{% url 'sgi_generation_labels' %}",
                    type: "GET",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    success: function (labels) {
                        generationLabels = labels;
                        loadGenerationGraph(labels);
                    },
                    error: function () {
                        console.error("Rule error");
                    }
                });

                $('#from_date').datepicker({
                    language: 'en',
                    format: "yyyy-mm-dd",
                    todayBtn: "linked",
                    autoclose: true,
                    todayHighlight: true
                });
                $('#to_date').datepicker({
                    language: 'en',
                    format: "yyyy-mm-dd",
                    todayBtn: "linked",
                    autoclose: true,
                    todayHighlight: true
                });


            });

            function generateGraphs() {
                var start = $("#from_date").val(); 
                var end = $("#to_date").val(); 
                charts[1] = {};
                charts[2] = {};
                    
                if (start == "" || end == "") {
                    swal({
                        title: "Generate graphs",
                        text: 'Please declare the data of interest!',
                        type: "info",
                        confirmButtonText: "Continue",
                        confirmButtonColor: "btn-info"
                    });
                }   

                var consURL = "consumption/from/" + start + "/until/" + end + "/";
                var genURL = "generation/from/" + start + "/until/" + end + "/";

                var data = [];
                var data_list = [];
                $.getJSON(genURL, {
                    format: "json"
                }).done(function (response) {
                    for (var i in generationLabels) {
                        data[i] = []    
                        data_list[i] = [];
                        for (var d in response) {
                            if (response[d]["Unique_CHA_No"] == generationLabels[i]["Unique_CHA_No"]) {
                                data[i].push(response[d]);
                            }
                        }
                        data_list[i] = parse_measurements(data[i]);
                    }
                    
                    if (!jQuery.isEmptyObject(charts[2])) {
                        for (var i in generationLabels){
                            charts[2].series[i].setData(data_list[i], true, false);
                        }
                    } else {
                        for (i in generationLabels){
                            if (i == 0){
                                plotline(2, 'chart_generation', data_list[i], 'Smart Grid Energy Generation', 'Energy', generationLabels[i]["Unique_CHA_No"], '#3FBAB2');
                            }
                            else {
                                var colors = ["#348DA5", "#4DADC6", "red", "green", "blue", "cyan",  "#67A3D8", "#9F86EA", "#8D34FF"];
                                charts[2].addSeries({ data: data_list[i], name: generationLabels[i]["Unique_CHA_No"], color: colors[i], marker: { enabled: false }, type: 'spline' });
                            }
                        }
                    }
                });

                var data = [];
                var data_list = [];
                $.getJSON(consURL, {
                    format: "json"
                }).done(function (response) {
                    for (var i in consumptionLabels) {
                        data[i] = []    
                        data_list[i] = [];
                        for (var d in response) {
                            if (response[d]["Unique_CHA_No"] == consumptionLabels[i]["Unique_CHA_No"]) {
                                data[i].push(response[d]);
                            }
                        }
                        data_list[i] = parse_measurements(data[i]);
                    }

                    if (!jQuery.isEmptyObject(charts[1])) {
                        for (var i in consumptionLabels){
                            charts[1].series[i].setData(data_list[i], true, false);
                        }
                    } else {
                        for (i in consumptionLabels){
                            if (i == 0){
                                plotline(1, 'chart_consumption', data_list[i], 'Smart Grid Energy Consumption', 'Energy', consumptionLabels[i]["Unique_CHA_No"], '#2EAADD');
                            }
                            else {
                                var colors = ["#348DA5", "#4DADC6", "red", "green",  "blue", "cyan", "#67A3D8", "#9F86EA", "#8D34FF"];
                                charts[1].addSeries({ data: data_list[i], name: consumptionLabels[i]["Unique_CHA_No"], color: colors[i], marker: { enabled: false }, type: 'spline' });
                            }
                        }
                    }
                });
                return false;
            }
            
            function loadConsumptionGraph(labels) {
                var data = [];
                var data_list = [];

                $.getJSON("{{url_consumption}}?q=date", {
                    format: "json"
                }).done(function (response) {
                    for (var i in labels) {
                        data[i] = []    
                        data_list[i] = [];
                        for (var d in response) {
                            if (response[d]["Unique_CHA_No"] == labels[i]["Unique_CHA_No"]) {
                                data[i].push(response[d]);
                            }
                        }
                        data_list[i] = parse_measurements(data[i]);
                    }

                    if (!jQuery.isEmptyObject(charts[1])) {
                        for (var i in labels){
                            charts[1].series[i].setData(data_list[i], true, false);
                        }
                    } else {
                        for (i in labels){
                            if (i == 0){
                                plotline(1, 'chart_consumption', data_list[i], 'Smart Grid Energy Consumption', 'Energy', labels[i]["Unique_CHA_No"], '#2EAADD');
                            }
                            else {
                                var colors = ["#348DA5", "#4DADC6", "red", "green",  "blue", "cyan", "#67A3D8", "#9F86EA", "#8D34FF"];
                                charts[1].addSeries({ data: data_list[i], name: labels[i]["Unique_CHA_No"], color: colors[i], marker: { enabled: false }, type: 'spline' });
                            }
                        }
                    }
                });
            }

            function loadGenerationGraph(labels) {
                var data = [];
                var data_list = [];

                $.getJSON("{{url_generation}}?q=date", {
                    format: "json"
                }).done(function (response) {  
                    for (var i in labels) {
                        data[i] = []    
                        data_list[i] = [];
                        for (var d in response) {
                            if (response[d]["Unique_CHA_No"] == labels[i]["Unique_CHA_No"]) {
                                data[i].push(response[d]);
                            }
                        }
                        data_list[i] = parse_measurements(data[i]);
                    }
                    
                    if (!jQuery.isEmptyObject(charts[2])) {
                        for (var i in labels){
                            charts[2].series[i].setData(data_list[i], true, false);
                        }
                    } else {
                        for (i in labels){
                            if (i == 0){
                                plotline(2, 'chart_generation', data_list[i], 'Smart Grid Energy Generation', 'Energy', labels[i]["Unique_CHA_No"], '#3FBAB2');
                            }
                            else {
                                var colors = ["#348DA5", "#4DADC6", "red", "green", "blue", "cyan",  "#67A3D8", "#9F86EA", "#8D34FF"];
                                charts[2].addSeries({ data: data_list[i], name: labels[i]["Unique_CHA_No"], color: colors[i], marker: { enabled: false }, type: 'spline' });
                            }
                        }
                    }
                });
            }

        </script>


        <div id="filter_data" class="text-center" style="margin-bottom: 50px">
            <form class="form-inline" name="filter_data">
                <div class="form-group">
                    <input type="text" class="form-control" id="from_date" placeholder="Start date" required readonly>
                </div>
                <div class="form-group">
                    <input type="text" class="form-control" id="to_date" placeholder="End date" required readonly>
                </div>
                <a id="filter_data" onclick="generateGraphs()" class="btn btn-catalyst btn-md"><i class="glyphicon glyphicon-search"></i> Filter</a>
            </form>
        </div>

        <div id="chart_consumption" class="demo-container"></div>
        <div id="chart_generation" class="demo-container"></div>

    {% endif %}

{% endblock %}
